<?php
class ControllerExtensionModuleRouteeCustomers extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/customers');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_process', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/customers', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}

		if( 1 == $this->config->get('module_routee_customer_exported') ) {
			$data['customer_exists'] = 0;
		} else {
			$data['customer_exists'] = 1;
		}
		
		
		$data['token'] = $this->session->data['token'];

        $data['insert_mass'] = $this->url->link('extension/module/routee/customers/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/customers/insert_mass', 'token=' . $this->session->data['token'], true));

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/customers', $data));
	}
	
	public function insert_mass() {
        $action = $_POST['action'];
        $token  = $_GET['token'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/customers');
        $reload = 0;
        if ( $this->session->data['token'] != $token || empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $limit = 100;
            $this->load->model('customer/customer');
            $this->load->model('extension/module/customer_cart');
            $filter_data = array(
                'sort'    => 'name',
                'order'   => 'ASC',
            );
            if ($action == "get_count") {
                $customerData = $this->model_customer_customer->getCustomers($filter_data);
                $t_count = count($customerData);
                if ($t_count == 0){
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'count' => $t_count
                    );
                }

            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * 100;
                $customerInfo = [];
                $customerData = $this->model_customer_customer->getCustomers($filter_data);
                $c_count = count($customerData);

                foreach($customerData as $k => $customerRow) {
                    $customerRow['id'] = $customerRow['customer_id'];
                    $customerRow['phone'] = $customerRow['telephone'];

                    unset($customerRow['cart']);
                    $customerCartData = $this->model_extension_module_customer_cart->getCart($customerRow['customer_id']);

                    $customerCart = array();
                    if($customerCartData)
                    {
                        foreach($customerCartData as $k => $cartData)
                        {
                            $customerCart['cart_products'][] = array('product_id' => $cartData['product_id'], 'option' => $cartData['option'], 'quantity' => $cartData['quantity']);
                        }
                    }
                    $customerAddressData = $this->model_customer_customer->getAddresses($customerRow['customer_id']);

                    $customerAddress = array();
                    if($customerAddressData)
                    {
                        foreach($customerAddressData as $k => $cartAddressRow)
                        {
                            $cartAddressRow['address1'] = $cartAddressRow['address_1'];
                            $cartAddressRow['address2'] = $cartAddressRow['address_2'];

                            unset($cartAddressRow['address_1']);
                            unset($cartAddressRow['address_2']);

                            $customerAddress[] = $cartAddressRow;
                        }
                    }
                    unset($customerRow['customer_id']);
                    unset($customerRow['telephone']);
                    $customerInfo[] = array('customer' => $customerRow, 'cart' => $customerCart, 'addresses' => $customerAddress);
                }
                $resultJson = $this->send_data($uuid, $customerInfo);
                if (!isset($resultJson)){
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])){
                    if ($c_count < 100){
                        $this->load->model('setting/setting');
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_customer_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }

        }
        echo json_encode($result);
        exit;
	}

    public function send_data($uuid, $customerInfo) {
        $data["uuid"] = $uuid;
        $data['data'][0] = array(
            'name' => 'Customers',
            'description' => 'Shop Customers',
            'object' => $customerInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Customers: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
