<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <?php if ($wishlist_exists == 1): ?>
                <a href="<?php echo $insert_mass; ?>" data-toggle="tooltip" title="<?php echo $button_insert_mass; ?>" class="btn btn-primary insert-mass"><i class="fa fa-plus"></i> <?php echo $button_insert_mass; ?></a>
                <?php endif; ?>
            </div>
            <h1><?php echo $heading_title; ?></h1>
            <ul class="breadcrumb">
                <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                <?php } ?>
            </ul>
        </div>
    </div>
    <div class="container-fluid">
        <?php if ($error_warning): ?>
        <div class="alert alert-danger alert-dismissible"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php endif; ?>
        <?php if ($success): ?>
        <div class="alert alert-success alert-dismissible"><i class="fa fa-check-circle"></i> <?php echo $success; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php endif; ?>
        <div class="alert alert-info alert-dismissible data-info" style="display: none"><i class="fa fa-refresh fa-spin"></i><?php echo $text_process; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
    </div>
</div>

<?php echo $footer; ?>

<script type="text/javascript">
    let url;
    let count = 1;
    $(".insert-mass").click(function (event) {
        event.preventDefault();
        $(this).addClass("disabled");
        url = $(".insert-mass").attr("href");
        let load = {action : "get_count"};
        make_ajax(load)
    });

    function make_ajax(data) {
        $.ajax({
            type: "POST",
            url: url,
            data: data,
            dataType: 'json',
            // async : false,
            // cache: false,
        }).fail(function (jqXHR, textStatus, errorThrown) {
            console.log('error ' + textStatus);
        }).done(function (data, textStatus, jqXHR) {
            process_result(data)
        });
    }

    function show_info_message(count) {
        let text = $(".data-info b").text();
        text = text.replace("~~count~~", count);
        $(".data-info b").text(text);
        $(".data-info").show();
    }

    function process_result(data) {
        if (data.reload === 1){
            location.reload();
        } else if (data.reload === 0){
            if (data.hasOwnProperty("count") && data.count > 0) {
                show_info_message(data.count);
            }
            let req = {
                action : "export_data",
                cycle_count : count
            };
            count++;
            make_ajax(req);
        }
    }
</script>